// 
// 6 DOF Robot demo program including positions saved to EEPROM so not lost on power failure
// Now includes slow JOG+ and JOG- to move slowly forward and backward between points.
// Now includes INC button to toggle between 1 and 5. Can increment or decrement values by 1 or 5 to save clicks when making big changes.

#include <ArduinoOTA.h>        //*** Enables wireless O-ver T-he A-ir uploads. 1 of 3 lines
#include <EEPROM.h>            //EEPROM library to store robot point data
// start reading from the first byte (address 0) of the EEPROM

#include <Wire.h>               /*Used for I2C*/
#include <Adafruit_ADS1015.h>    /*Analog Expander Board*/
Adafruit_ADS1115 ads;  /* Use this for the 16-bit version */


#include <Servo.h>
Servo servo;
WiFiServer server(80);         //Used for WiFi Server

int analoginput;
int lastSecond = -1; // set last second to impossible number so it prints right away then every second
int lastSecond1 = -1; // used to reset alert only once per second
String request, timedate, Month, Day, Hour, Minute, Second, dow, distancestring;
String tempdata, indexdata, servodata;
float temp1, t2, temp2;
int mov, lastmov, j, k, l, m, n, o, x, y, z, psn1, psn2, p, vplus, vneg, val;
int a0, a1, a2, a3, a4, a0cal, a1cal, a2cal, a3cal, a4cal;
int slot1, slot2, slot3, slot4, slot5;

int speeddelay = 30; // controls delay moving slowing between points. Smaller is faster
int pause = 300; // after moving to new point robot waits before going to next point
int inc = 1;

int intdata, save, lastsave, value, readctr, lastreadctr, readeeprom, addr, addrinc, address, addressinc ;

  Servo servo1;
  Servo servo2;
  Servo servo3;
  Servo servo4;
  Servo servo5;
  Servo servo6;

//******Define number of robot points here. Array definition must be integers not variables**************************

int numberofpoints = 15; // array definition must be integers not variables
int pos1[15], pos2[15], pos3[15], pos4[15], pos5[15], pos6[15] ;  // array definition must be integers not variables

//******End Define number of robot points here. Array definition must be integers not variables**************************
  
void setup() {



  
  ArduinoOTA.begin();           //*** Enables OTA programming. 2 of 3 lines

  Wire.begin(D8, D7);// Start I2C on D8 brown and D7 orange for analog expander

  EEPROM.begin(512);

          pos1[0] = EEPROM.read(0);  // read initial positions from EEPROM on boot or else it goes to mid position at servo.attach         
          pos2[0] = EEPROM.read(1);            
          pos3[0] = EEPROM.read(2);          
          pos4[0] = EEPROM.read(3);          
          pos5[0] = EEPROM.read(4);         
          pos6[0] = EEPROM.read(5);    

/*
          pos1[0] = 60;  // initial positions        
          pos2[0] = 130;            
          pos3[0] = 5;          
          pos4[0] = 120;          
          pos5[0] = 100;         
          pos6[0] = 0;

    
 
  servo1.attach(D1, 500, 2500); // pin, servo PWM range for HS422
  servo2.attach(D2, 500, 2500); // pin, servo PWM range for HS422
  servo3.attach(D3, 500, 2500); // pin, servo PWM range for HS422
  servo4.attach(D4, 500, 2500); // pin, servo PWM range for HS422
  servo5.attach(D5, 500, 2500); // pin, servo PWM range for HS422
  servo6.attach(D6, 500, 2500); // pin, servo PWM range for HS422

*/

  servo1.attach(D1, 771, 2740); // pin, servo PWM range for MG996R
  servo2.attach(D2, 771, 2740); // pin, servo PWM range for MG996R
  servo3.attach(D3, 771, 2740); // pin, servo PWM range for MG996R
  servo4.attach(D4, 771, 2740); // pin, servo PWM range for MG996R
  servo5.attach(D5, 771, 2740); // pin, servo PWM range for MG996R
  servo6.attach(D6, 771, 2740); // pin, servo PWM range for MG996R


          servo1.write(pos1[0]);// set initial positions on boot or else it goes to mid position at servo.attach
          servo2.write(pos2[0]);
          servo3.write(pos3[0]);
          servo4.write(pos4[0]);
          servo5.write(pos5[0]);
          servo6.write(pos6[0]);
  
   server.begin();
   ads.begin(); // Analog expander
//   pinMode(D0, INPUT);     // Initialize D0 pin as an input Ultrasonic echo on Nodemcu 12E board   
   
    
// Initialize relay outputs to HIGH since LOW activates the relay 
   
//    digitalWrite(D7, HIGH); // Relay 1 
//    digitalWrite(D8, HIGH); // Relay 2 
     
      }
int  automode = 0; // default mode is AUTO OFF mode 
int i=0;
int s=1;
int boot=0;
int robotpoint, nextrobotpoint;



void loop() {
  
  ArduinoOTA.handle();     //*** Enables OTA uploads. 3 of 3 lines

// *********AUTO mode execute moves through all points for all servos************************************
// Point and next point data sent to speedcontrol function to slowly move between points*****************

  if ((automode == 1) && (boot > 0)){ // don't run AUTO sequence if data not READ yet 
      robotpoint = 0;  
      nextrobotpoint = 1;
      
        while (robotpoint <= (numberofpoints-2)) {
  
        speedcontrol(pos1[robotpoint], pos1[nextrobotpoint], pos2[robotpoint], pos2[nextrobotpoint], pos3[robotpoint], pos3[nextrobotpoint], pos4[robotpoint], pos4[nextrobotpoint], pos5[robotpoint], pos5[nextrobotpoint], pos6[robotpoint], pos6[nextrobotpoint] );
        delay(pause);
//        if (robotpoint == 3) delay(3000); // add delay for pour
   
        robotpoint = robotpoint +1;
        nextrobotpoint = nextrobotpoint +1;
        }
        
     // Move to intial position at end of AUTO cycle
        speedcontrol(pos1[robotpoint], pos1[0], pos2[robotpoint], pos2[0], pos3[robotpoint], pos3[0], pos4[robotpoint], pos4[0], pos5[robotpoint], pos5[0], pos6[robotpoint], pos6[0] );
        delay(pause);
    automode = 0; 
  }
  
// *********END AUTO mode execute moves through all points for all servos***********************************


//***Move to new teach point on MOVE button*******************************

  if ((automode == 0) && (readctr > 0) && (lastmov != mov)){ // move to new teach position if all points not zero and at least 1 EEPROM read
    lastmov = mov;
    servo1.write(pos1[i]);
    servo2.write(pos2[i]);
    servo3.write(pos3[i]);
    servo4.write(pos4[i]);
    servo5.write(pos5[i]);
    servo6.write(pos6[i]);
  }
  
//***End Move to new teach point on MOVE button***************************


//***Save to EEPROM robot points on SAVE button****************************

    if ((automode == 0) && (lastsave != save)){ // save point data
     lastsave = save;
      addr=0; // position number
      addrinc=0;
        while(addr < numberofpoints ){
          EEPROM.write(addrinc, pos1[addr]);
            addrinc=addrinc+1;
          EEPROM.write(addrinc, pos2[addr]);
            addrinc=addrinc+1;
          EEPROM.write(addrinc, pos3[addr]);
            addrinc=addrinc+1;
          EEPROM.write(addrinc, pos4[addr]);
            addrinc=addrinc+1;
          EEPROM.write(addrinc, pos5[addr]);
            addrinc=addrinc+1;
          EEPROM.write(addrinc, pos6[addr]);
            addrinc=addrinc+1;
            addr = addr + 1;
        }
        EEPROM.commit(); // copy entire contents to EEPROM only writes if data is different
  }

//***End Save to EEPROM robot points on SAVE button****************************

//***Read EEPROM robot points on READ button****************************

    if ((boot == 0) || ((automode == 0) && (lastreadctr != readctr))){ // read point data on boot and on READ button
     lastreadctr = readctr;
     
      address=0; // position number
      addressinc=0;
        while(address < numberofpoints ){
          pos1[address] = EEPROM.read(addressinc);
            addressinc = addressinc +1;
          pos2[address] = EEPROM.read(addressinc);
            addressinc = addressinc +1;
          pos3[address] = EEPROM.read(addressinc);
            addressinc = addressinc +1;
          pos4[address] = EEPROM.read(addressinc);
            addressinc = addressinc +1;
          pos5[address] = EEPROM.read(addressinc);
            addressinc = addressinc +1;
          pos6[address] = EEPROM.read(addressinc);
            addressinc = addressinc +1;
            address = address + 1;
        }
            boot = 1;  
    }
    
//***End Read EEPROM robot points on READ button****************************


/*FWD/RVRS Motor Demo
 digitalWrite(D7, LOW); // Relay 1 
 delay (1000);
 digitalWrite(D7, HIGH); // Relay 1 
 delay (1000);
 digitalWrite(D8, LOW); // Relay 2 
  delay (1000);
 digitalWrite(D7, LOW); // Relay 1 
 delay (1000);
  digitalWrite(D7, HIGH); // Relay 1 
 delay (1000);
 digitalWrite(D8, HIGH); // Relay 2 
 delay (1000);
*/

//*******Analog Read*************
     a0 = analogRead(0); // read analog A0 4 more analog inputs with ADS-1115
     
       int16_t adc0, adc1, adc2, adc3;

      adc0 = ads.readADC_SingleEnded(0);
      a1 = adc0/10;
      adc1 = ads.readADC_SingleEnded(1);
      a2 = adc1/10;
      adc2 = ads.readADC_SingleEnded(2);
      a3 = adc2/10;
      adc3 = ads.readADC_SingleEnded(3);
      a4 = adc3/10;

     if (i == 5){// read analog inputs when ball is at top
      a0cal = a0;
      a1cal = a1;
      a2cal = a2;
      a3cal = a3;
      a4cal = a4;
     }
     if (i == 0) {
       if ((a0 - a0cal) > 100)  slot1=1;
       if ((a0 - a0cal) <= 100) slot1=0;
       
       if ((a1 - a1cal) > 100)  slot2=1;
       if ((a1 - a1cal) <= 100) slot2=0;

       if ((a2 - a2cal) > 100)  slot3=1;
       if ((a2 - a2cal) <= 100) slot3=0;

       if ((a3 - a3cal) > 100)  slot4=1;
       if ((a3 - a3cal) <= 100) slot4=0;

       if ((a4 - a4cal) > 100)  slot5=1;
       if ((a4 - a4cal) <= 100) slot5=0;
       
     }
//  Serial.print("AIN0: "); Serial.println(adc0);
//  Serial.print("AIN1: "); Serial.println(adc1);
//  Serial.print("AIN2: "); Serial.println(adc2);
//  Serial.print("AIN3: "); Serial.println(adc3);
//  Serial.println(" ");



     
//*******End analog read**********

//*******Plinko Point Data. Change initial points based on ball slot position

if ((i == 0) && (slot1 == 1) && (slot2 == 0) && (slot3 == 0) && (slot4 == 0) && (slot5 == 0)) {// slot 1
    pos1[1] = 0; 
    pos2[1] = 75; 
    pos3[1] = 55; 
    pos4[1] = 55; 
    pos5[1] = 80; 
    pos6[1] = 15; 

    pos1[2] = 0; 
    pos2[2] = 64; 
    pos3[2] = 55; 
    pos4[2] = 58; 
    pos5[2] = 80; 
    pos6[2] = 15;

    pos1[3] = 0; 
    pos2[3] = 64; 
    pos3[3] = 55; 
    pos4[3] = 58; 
    pos5[3] = 80; 
    pos6[3] = 46;

    pos1[4] = 0; 
    pos2[4] = 95; 
    pos3[4] = 55; 
    pos4[4] = 58; 
    pos5[4] = 80; 
    pos6[4] = 46;

    pos1[5] = 60; 
    pos2[5] = 115; 
    pos3[5] = 55; 
    pos4[5] = 80; 
    pos5[5] = 10; 
    pos6[5] = 46;

    pos1[6] = 60; 
    pos2[6] = 115; 
    pos3[6] = 55; 
    pos4[6] = 80; 
    pos5[6] = 10; 
    pos6[6] = 46;
    
}

if ((i == 0) && (slot1 == 0) && (slot2 == 1) && (slot3 == 0) && (slot4 == 0) && (slot5 == 0)) {// slot 2
    pos1[1] = 14; 
    pos2[1] = 65; 
    pos3[1] = 65; 
    pos4[1] = 65; 
    pos5[1] = 110; 
    pos6[1] = 15; 

    pos1[2] = 14; 
    pos2[2] = 53; 
    pos3[2] = 65; 
    pos4[2] = 65; 
    pos5[2] = 110; 
    pos6[2] = 15;

    pos1[3] = 14; 
    pos2[3] = 53; 
    pos3[3] = 65; 
    pos4[3] = 65; 
    pos5[3] = 110; 
    pos6[3] = 46;

    pos1[4] = 14; 
    pos2[4] = 95; 
    pos3[4] = 65; 
    pos4[4] = 65; 
    pos5[4] = 110; 
    pos6[4] = 46;

    pos1[5] = 60; 
    pos2[5] = 115; 
    pos3[5] = 55; 
    pos4[5] = 80; 
    pos5[5] = 10; 
    pos6[5] = 46;

    pos1[6] = 60; 
    pos2[6] = 115; 
    pos3[6] = 55; 
    pos4[6] = 80; 
    pos5[6] = 10; 
    pos6[6] = 46;
    
}

if ((i == 0) && (slot1 == 0) && (slot2 == 0) && (slot3 == 1) && (slot4 == 0) && (slot5 == 0)) {// slot 3
    pos1[1] = 23; 
    pos2[1] = 50; 
    pos3[1] = 80; 
    pos4[1] = 68; 
    pos5[1] = 110; 
    pos6[1] = 15; 

    pos1[2] = 23; 
    pos2[2] = 40; 
    pos3[2] = 80; 
    pos4[2] = 68; 
    pos5[2] = 110; 
    pos6[2] = 15;

    pos1[3] = 23; 
    pos2[3] = 40; 
    pos3[3] = 80; 
    pos4[3] = 68; 
    pos5[3] = 110; 
    pos6[3] = 46;

    pos1[4] = 23; 
    pos2[4] = 95; 
    pos3[4] = 80; 
    pos4[4] = 75; 
    pos5[4] = 110; 
    pos6[4] = 46;

    pos1[5] = 60; 
    pos2[5] = 115; 
    pos3[5] = 55; 
    pos4[5] = 80; 
    pos5[5] = 10; 
    pos6[5] = 46;

    pos1[6] = 60; 
    pos2[6] = 115; 
    pos3[6] = 55; 
    pos4[6] = 80; 
    pos5[6] = 10; 
    pos6[6] = 46;
    
}

if ((i == 0) && (slot1 == 0) && (slot2 == 0) && (slot3 == 0) && (slot4 == 1) && (slot5 == 0)) {// slot 4
    pos1[1] = 29; 
    pos2[1] = 40; 
    pos3[1] = 94; 
    pos4[1] = 79; 
    pos5[1] = 115; 
    pos6[1] = 15; 

    pos1[2] = 29; 
    pos2[2] = 30; 
    pos3[2] = 94; 
    pos4[2] = 79; 
    pos5[2] = 115; 
    pos6[2] = 15;

    pos1[3] = 29; 
    pos2[3] = 30; 
    pos3[3] = 94; 
    pos4[3] = 79; 
    pos5[3] = 115; 
    pos6[3] = 46;

    pos1[4] = 29; 
    pos2[4] = 80; 
    pos3[4] = 94; 
    pos4[4] = 79; 
    pos5[4] = 115; 
    pos6[4] = 46;

    pos1[5] = 60; 
    pos2[5] = 115; 
    pos3[5] = 55; 
    pos4[5] = 80; 
    pos5[5] = 10; 
    pos6[5] = 46;

    pos1[6] = 60; 
    pos2[6] = 115; 
    pos3[6] = 55; 
    pos4[6] = 80; 
    pos5[6] = 10; 
    pos6[6] = 46;
    
}

if ((i == 0) && (slot1 == 0) && (slot2 == 0) && (slot3 == 0) && (slot4 == 0) && (slot5 == 1)) {// slot 5
    pos1[1] = 33; 
    pos2[1] = 100; 
    pos3[1] = 55; 
    pos4[1] = 130; 
    pos5[1] = 10; 
    pos6[1] = 15; 

    pos1[2] = 33; 
    pos2[2] = 17; 
    pos3[2] = 89; 
    pos4[2] = 130; 
    pos5[2] = 0; 
    pos6[2] = 15;

    pos1[3] = 33; 
    pos2[3] = 17; 
    pos3[3] = 89; 
    pos4[3] = 117; 
    pos5[3] = 0; 
    pos6[3] = 15;

    pos1[4] = 33; 
    pos2[4] = 17; 
    pos3[4] = 89; 
    pos4[4] = 117; 
    pos5[4] = 0; 
    pos6[4] = 46;

    pos1[5] = 33; 
    pos2[5] = 21; 
    pos3[5] = 95; 
    pos4[5] = 130; 
    pos5[5] = 10; 
    pos6[5] = 46;

    pos1[6] = 33; 
    pos2[6] = 95; 
    pos3[6] = 55; 
    pos4[6] = 130; 
    pos5[6] = 10; 
    pos6[6] = 46;
    
}

//*******End Plinko Point Data

//*******WiFi detect client and record input***********************************

// Check if a client has connected
  WiFiClient client = server.available();
  if (!client) {
    return;
  }
  // Read the first line of the request
      request = client.readStringUntil('\r');
  
   client.flush();
   
//*******End of WiFi detect client and record input********************************

//*************Actions on web page button click. Buttons defined below.************

if (request.indexOf("/SRV+=ON") != -1)  {
      
    if ((automode == 0) && (s < 6)) s = s+1;  
   
  }
  if (request.indexOf("/SRV-=ON") != -1) {
     
    
    if ((automode == 0) && (s > 1)) s = s-1; 
   
     }

// Match the web page button request 
 
 if (request.indexOf("/POS+=ON") != -1)  {
      
    if ((automode == 0) && (i < (numberofpoints-1))) i = i+1; 
   
  }
  if (request.indexOf("/POS-=ON") != -1) {
     
    
    if ((automode == 0) && (i > 0)) i = i-1; 
   
     }

     

       if (request.indexOf("/VAL+=ON") != -1)  {
            if ((automode == 0) && (s == 1) && (pos1[i] < 130) && (inc == 1)) pos1[i] = pos1[i]+1;
            if ((automode == 0) && (s == 1) && (pos1[i] < 126) && (inc == 5)) pos1[i] = pos1[i]+5;
            if ((automode == 0) && (s == 2) && (pos2[i] < 130) && (inc == 1)) pos2[i] = pos2[i]+1;
            if ((automode == 0) && (s == 2) && (pos2[i] < 126) && (inc == 5)) pos2[i] = pos2[i]+5;
            if ((automode == 0) && (s == 3) && (pos3[i] < 130) && (inc == 1)) pos3[i] = pos3[i]+1;
            if ((automode == 0) && (s == 3) && (pos3[i] < 126) && (inc == 5)) pos3[i] = pos3[i]+5;
            if ((automode == 0) && (s == 4) && (pos4[i] < 130) && (inc == 1)) pos4[i] = pos4[i]+1;
            if ((automode == 0) && (s == 4) && (pos4[i] < 126) && (inc == 5)) pos4[i] = pos4[i]+5;
            if ((automode == 0) && (s == 5) && (pos5[i] < 130) && (inc == 1)) pos5[i] = pos5[i]+1;
            if ((automode == 0) && (s == 5) && (pos5[i] < 126) && (inc == 5)) pos5[i] = pos5[i]+5;
            if ((automode == 0) && (s == 6) && (pos6[i] < 130) && (inc == 1)) pos6[i] = pos6[i]+1;
            if ((automode == 0) && (s == 6) && (pos6[i] < 126) && (inc == 5)) pos6[i] = pos6[i]+5;                             
    }
      if (request.indexOf("/VAL-=ON") != -1)  {// Input from screen. No spaces in name.
            if ((automode == 0) && (s == 1) && (pos1[i] > 0) && (inc == 1)) pos1[i] = pos1[i]-1;
            if ((automode == 0) && (s == 1) && (pos1[i] > 4) && (inc == 5)) pos1[i] = pos1[i]-5;
            if ((automode == 0) && (s == 2) && (pos2[i] > 0) && (inc == 1)) pos2[i] = pos2[i]-1;
            if ((automode == 0) && (s == 2) && (pos2[i] > 4) && (inc == 5)) pos2[i] = pos2[i]-5;
            if ((automode == 0) && (s == 3) && (pos3[i] > 0) && (inc == 1)) pos3[i] = pos3[i]-1;
            if ((automode == 0) && (s == 3) && (pos3[i] > 4) && (inc == 5)) pos3[i] = pos3[i]-5;
            if ((automode == 0) && (s == 4) && (pos4[i] > 0) && (inc == 1)) pos4[i] = pos4[i]-1;
            if ((automode == 0) && (s == 4) && (pos4[i] > 4) && (inc == 5)) pos4[i] = pos4[i]-5;
            if ((automode == 0) && (s == 5) && (pos5[i] > 0) && (inc == 1)) pos5[i] = pos5[i]-1;
            if ((automode == 0) && (s == 5) && (pos5[i] > 4) && (inc == 5)) pos5[i] = pos5[i]-5;
            if ((automode == 0) && (s == 6) && (pos6[i] > 0) && (inc == 1)) pos6[i] = pos6[i]-1;
            if ((automode == 0) && (s == 6) && (pos6[i] > 4) && (inc == 5)) pos6[i] = pos6[i]-5;
    }


if (request.indexOf("/INC") != -1)  {
      
    if (inc == 5){
      inc = 1; 
      goto last;
    }  
    if (inc == 1) inc = 5;
    last:;
  }


   
  if ((request.indexOf("/AUTO") != -1) && (boot = 1) && (i == 0))  {// Input from screen. No spaces in name. Boot = 1 at end of first READ EEPROM data before AUTO mode
    
     automode = 1; // set auto mode ON on button click
     } 
     
  if ((request.indexOf("/JOG+") != -1) && (boot = 1)) {// Input from screen. No spaces in name. 
    robotpoint = i;  
     if (i < 14) nextrobotpoint = i+1;
     if (i == 14) nextrobotpoint = 0;
      
        speedcontrol(pos1[robotpoint], pos1[nextrobotpoint], pos2[robotpoint], pos2[nextrobotpoint], pos3[robotpoint], pos3[nextrobotpoint], pos4[robotpoint], pos4[nextrobotpoint], pos5[robotpoint], pos5[nextrobotpoint], pos6[robotpoint], pos6[nextrobotpoint] );
      
      i = nextrobotpoint;
     }

    if ((request.indexOf("/JOG-") != -1) && (boot = 1)) {// Input from screen. No spaces in name. 
    robotpoint = i;  
     if (i > 0) nextrobotpoint = i-1;
     if (i == 0) nextrobotpoint = 0;
      
        speedcontrol(pos1[robotpoint], pos1[nextrobotpoint], pos2[robotpoint], pos2[nextrobotpoint], pos3[robotpoint], pos3[nextrobotpoint], pos4[robotpoint], pos4[nextrobotpoint], pos5[robotpoint], pos5[nextrobotpoint], pos6[robotpoint], pos6[nextrobotpoint] );
      
      i = nextrobotpoint;
     }
        
  if (request.indexOf("/MOV") != -1)  {// Input from screen. No spaces in name. 
    
     if (automode == 0) mov = mov + 1; // bit to send current pos1tion value to servo
   
     } 

//***EEPROM SAVE counter****************************************************************

 if ((request.indexOf("/SAVE") != -1)  && (readctr > 0))   {// Input from screen. No spaces in name. Must READ first before SAVE.
    
     if (automode == 0) save = save + 1; // bit to send current pos1tion value to servo
   
     } 
 
//***END EEPROM SAVE counter*************************************************************


//***EEPROM READ counter****************************************************************

 if (request.indexOf("/READ") != -1)  {// Input from screen. No spaces in name. 
    
     if (automode == 0) readctr = readctr + 1; // bit to send current pos1tion value to servo
   
     } 
 
//***END EEPROM READ counter*************************************************************


   request.indexOf("/REFRESH");  // Refresh web page
 
 
//*******End of web page button actions*********************************************

//****** Return the response in HTML on web page************************************

  client.println("HTTP/1.1 200 OK");
  client.println("Content-Type: text/html");
  client.println(""); //  do not forget this one
  client.println("<!DOCTYPE HTML>");
  client.println( // start code html with this. Have to add quotes before and after. Delete most html quotes in line.
    "<html>"
        "<head>"
        
          "<title>Robot Demo</title>"
     
      "<meta name=viewport content=width=720px, initial-scale=1.0>"    
      "<meta name=viewport shrink-to-fit=yes>" 
       
        "</head>"
    "<style> r {font-size: 18px; color:blue; font-family:monospace;} </style>" //Use monospace font to make columns of text and numbers line up
    "<r>"); // large font applies between <q> and </q> below
    
 //*********End HTML page start of defintion*****************************************
 
  //*****Background Images** Use background= for all your jpgs. HTML pos1ition does not work. Add big white spc in jpg to right and below to stop repeats.
 /* 
 // client.println("<body background= https://sites.google.com/site/nodemcuwebpics/home/Frisbee.png no repeat");
  client.println("<body background= file:///C:/Users/jcwhi/Downloads/NodeMCU/robot.png no repeat");
  client.println("<background-repeat = no-repeat;>");
  client.println("</body>");
 
//*****End of background images******************************************************************
*/
 //*********Print Date and Time add leading zeroes to Web Page***********************************
 /*
  * 
    Hour = String(t.Hour()); // integers like t.Hour() are used for comparisons and control. Change to string for display and add leading zeroes
    
    if (t.Hour() <= 9) Hour = "0" + Hour;  // add leading zeroes for 0-9
      Minute = String(t.Minute());
    if (t.Minute() <= 9) Minute = "0" + Minute;  // add leading zeroes for 0-9
      Second = String(t.Second());
    if (t.Second() <= 9) Second = "0" + Second;  // add leading zeroes for 0-9
 
    if (t.DayOfWeek() == 0) dow = " Sun"; // t.DayOfWeek() calculated from rest of date not from DS3231
    if (t.DayOfWeek() == 1) dow = " Mon";
    if (t.DayOfWeek() == 2) dow = " Tue";
    if (t.DayOfWeek() == 3) dow = " Wed";
    if (t.DayOfWeek() == 4) dow = " Thu";
    if (t.DayOfWeek() == 5) dow = " Fri";
    if (t.DayOfWeek() == 6) dow = " Sat";
    Month = String(t.Month());
    Day = String(t.Day());
  
    if (t.Month() <= 9) Month = "0" + Month;  // adjust for 0-9 in month
    if (t.Day() <= 9) Day = "0" + Day;  // adjust for 0-9 in day
  
    timedate = String(t.Year())+ "/" + Month + "/" + Day + " " + Hour + ":" + Minute + ":" + Second ; // create string for display with one client.println
 */
 /*   client.println(timedate);
    client.println("&emsp;"); // add spaces
    client.println(dow); // print day of week
    client.println("&emsp;"); // add spaces  
    client.println("<br>"); // print empty line
 */   
//*********End Print Date and Time to Web Page ********************************************

//********Title Line**************************************************************   
    client.println("<br>"); 
   
    client.println("Servo Select");
    client.println(s);
    client.println("&emsp;&emsp;&emsp;&emsp;");
    client.println("Position Select");
    client.println(i);
    client.println("&emsp;");
    client.println("Value UP/DN");   
     if(s==1)client.println(pos1[i]);
     if(s==2)client.println(pos2[i]);
     if(s==3)client.println(pos3[i]);
     if(s==4)client.println(pos4[i]);
     if(s==5)client.println(pos5[i]);
     if(s==6)client.println(pos6[i]);
       client.println("&emsp;&emsp;&emsp;");
    client.println("Inc");
     client.println(inc);  
    client.println("<br>"); 
    client.println("</r>");
    
//********End Title Line**************************************************************   
    
//*********Web Page Button Style defintion CSS*********************************************
 
  client.println(  //html output. Put quotes around html code. Don't have to client.println every line
    "<style>" // button style definition
    ".button {"
    "background-color: #008CBA; /* Blue */"
    "border: none;"
    "border-radius: 4px;"
    "color: yellow;"
    "padding: 12px 24px;"
    "text-align: center;"
    "text-decoration: none;"
    "display: inline-block;"
    "font-size: 16px;"
    "}"
    "</style>"
    
//*****End Web Page Button Style Definition*************************************************

//******Servo 1 Web Page Buttons Definitions********************************************************

    "<br>"
    "<a href=\"/SRV+=ON\"\"><button class=button>SRV + </button></a>"   
    "&nbsp;" // horizontal space between buttons
    "<a href=\"/SRV-=ON\"\"><button class=button>SRV - </button></a>" 
    "&nbsp;"
    "<a href=\"/POS+=ON\"\"><button class=button>POS + </button></a>"  
    "&nbsp;" // horizontal space between buttons
    "<a href=\"/POS-=ON\"\"><button class=button>POS - </button></a>" 
    "&nbsp;"
    "<a href=\"/VAL+=ON\"\"><button class=button>VAL + </button></a>"      
    "&nbsp;" // horizontal space between buttons
    "<a href=\"/VAL-=ON\"\"><button class=button>VAL - </button></a>"   
    "&nbsp;" // horizontal space between buttons
    "<a href=\"/INC\"\"><button class=button>INC </button></a>"    
    "&emsp;" // horizontal space between buttons
    "<a href=\"/REFRESH\"\"><button class=button>REFRESH </button></a>"); 
      
//*****End Servo 1 Button Definition*****************************************************************


//***** Display data to web page*************************************************************
 
    client.println("<style> p {font-size: 18px; color:blue; font-family:monospace;} </style>" //Use monospace font to make columns of text and numbers line up
      "<p>"); // large font applies between <p> and </p> below 
//    servodata = "Servo " + String(s);
//    indexdata = "Index " + String(i);

//    client.println(servodata);
//    client.println("&emsp;&emsp;&emsp;&emsp;"); 
//    client.println(indexdata);
//    client.println("&emsp;"); 

    client.println("<br>");
    client.println("<br>");
    client.println("&emsp;&emsp;&emsp;&emsp;"); 
      
   client.println(
    
    //***Web page buttons***************
    
    "<a href=\"/AUTO\"\"><button class=button>AUTO</button></a>"
    "&nbsp;<a href=\"/JOG+\"\"><button class=button>JOG+</button></a>"
    "&nbsp;<a href=\"/JOG-\"\"><button class=button>JOG-</button></a>"
     "&nbsp;<a href=\"/MOV=ON\"\"><button class=button>MOVE</button></a>"
     "&nbsp;<a href=\"/SAVE=ON\"\"><button class=button>SAVE</button></a>"
     "&nbsp;<a href=\"/READ=ON\"\"><button class=button>READ</button></a>");
    
  //***End web page buttons*****************************************************   
  
  //****Print data to web page**************************************************
  
   client.println("<style> p {font-size: 18px; color:blue; font-family:monospace;} </style>" //Use monospace font to make columns of text and numbers line up
      "<p>"); // large font applies between <p> and </p> below
   client.println("&nbsp");
 
   client.println("&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;");
   
      if (automode == 1) client.println("AUTO MODE");
      if (automode == 0) client.println("TEACH MODE"); 
      client.println(mov);
      client.println(i);
      client.println("EEPROM");
      client.println(readctr);
      client.println("BOOT");
      client.println(boot);
    
      client.println("<br>");
     client.println("&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;&emsp;");
    client.println("<br>");
    
   client.println("<br>"); 
   client.println("<br>");

    client.println(" PSN "); 
    client.println("&nbsp;&nbsp");
    client.println(" SRV 1 "); 
    client.println("&nbsp;&nbsp");
    client.println(" SRV 2 "); 
    client.println("&nbsp;&nbsp");
    client.println(" SRV 3 "); 
    client.println("&nbsp;&nbsp");
    client.println(" SRV 4 "); 
    client.println("&nbsp;&nbsp");
    client.println(" SRV 5 "); 
    client.println("&nbsp;&nbsp");
    client.println(" SRV 6 "); 
       client.println("<br>"); 


//*********Display Point Data Loop*****************************************

      p=0; // position number
      while(p < numberofpoints ){
         
     //client.println("&emsp;");
    String Strpointnumber = String(p);
    Strpointnumber= "&nbsp" + Strpointnumber;
    if (p < 10) Strpointnumber= "&nbsp" + Strpointnumber;  // add leading spaces
    client.println(Strpointnumber); 
    
     client.println("&nbsp;&nbsp;&nbsp;");
    String StrPOS10 = String(pos1[p]);
    if (pos1[p] < 10) StrPOS10 = "&nbsp" + StrPOS10;  // add leading spaces
    if (pos1[p] < 100) StrPOS10 = "&nbsp" + StrPOS10;  // add leading spaces   
    client.println(StrPOS10);
    client.println("&nbsp;&nbsp;&nbsp;&nbsp;");

    String StrPOS20 = String(pos2[p]);
    if (pos2[p] < 10) StrPOS20 = "&nbsp" + StrPOS20;  // add leading spaces
    if (pos2[p] < 100) StrPOS20 = "&nbsp" + StrPOS20;  // add leading spaces   
    client.println(StrPOS20);
    client.println("&nbsp;&nbsp;&nbsp;&nbsp;");

    String StrPOS30 = String(pos3[p]);
    if (pos3[p] < 10) StrPOS30 = "&nbsp" + StrPOS30;  // add leading spaces
    if (pos3[p] < 100) StrPOS30 = "&nbsp" + StrPOS30;  // add leading spaces   
    client.println(StrPOS30);
    client.println("&nbsp;&nbsp;&nbsp;&nbsp;");

    String StrPOS40 = String(pos4[p]);
    if (pos4[p] < 10) StrPOS40 = "&nbsp" + StrPOS40;  // add leading spaces
    if (pos4[p] < 100) StrPOS40 = "&nbsp" + StrPOS40;  // add leading spaces   
    client.println(StrPOS40);
    client.println("&nbsp;&nbsp;&nbsp;&nbsp;");

    String StrPOS50 = String(pos5[p]);
    if (pos5[p] < 10) StrPOS50 = "&nbsp" + StrPOS50;  // add leading spaces
    if (pos5[p] < 100) StrPOS50 = "&nbsp" + StrPOS50;  // add leading spaces   
    client.println(StrPOS50);
    client.println("&nbsp;&nbsp;&nbsp;&nbsp;");

    String StrPOS60 = String(pos6[p]);
    if (pos6[p] < 10) StrPOS60 = "&nbsp" + StrPOS60;  // add leading spaces
    if (pos6[p] < 100) StrPOS60 = "&nbsp" + StrPOS60;  // add leading spaces   
    client.println(StrPOS60);
    client.println("&nbsp;&nbsp;&nbsp;&nbsp;");

   client.println("<br>"); // next line
    p=p+1;
    }
//*********End Display Point Data Loop*****************************************
    
    client.println("<br>"); 
    client.println("Analog");
    client.println(a0);       
    client.println(a1);
    client.println(a2);
    client.println(a3);
    client.println(a4);
    client.println("<br>"); 
    
    client.println("Calibr");
    client.println(a0cal);       
    client.println(a1cal);
    client.println(a2cal);
    client.println(a3cal);
    client.println(a4cal);
    client.println("<br>"); 

    client.println("InSlot");
    client.println(slot1);       
    client.println(slot2);
    client.println(slot3);
    client.println(slot4);
    client.println(slot5);
         
     client.println("<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"
     "<br>"       
     "<br>"
     "<br>"
     "<br>"    

 
    ".");    // add period below the background you want to display or it won't scroll past last text
    client.println("</p>"
      "</body>");
  
client.println("<br>");
  delay(1);
  


//****End Print data to web page**********************************************

client.println("</html>");
  delay(200);
 client.stop(); // disconnect client to allow other clients
  delay(1);


 
 }

void speedcontrol(int s1psn1, int s1psn2, int s2psn1, int s2psn2, int s3psn1, int s3psn2, int s4psn1, int s4psn2, int s5psn1, int s5psn2, int s6psn1, int s6psn2 )
{
j=s1psn1;
k=s2psn1;
l=s3psn1;
m=s4psn1;
n=s5psn1;
o=s6psn1;
  
  while((s1psn2 != j) || (s2psn2 != k) || (s3psn2 != l) || (s4psn2 != m) || (s5psn2 != n) || (s6psn2 != o) )
  {

//*****Servo 1 speed control**********
    
  if (s1psn2 < s1psn1){
      if(s1psn2 < j){
        j=j-1;
        servo1.write(j);
       }
      }
  if (s1psn2 > s1psn1){
      if(s1psn2 > j){
        j=j+1;
        servo1.write(j);    
      }
     }
     
//***** End Servo 1 speed control****


//*****Servo 2 speed control*********

  if (s2psn2 < s2psn1){
      if(s2psn2 < k){
        k=k-1;
        servo2.write(k);
       }
      }
  if (s2psn2 > s2psn1){
      if(s2psn2 > k){
        k=k+1;
        servo2.write(k);    
      }
     }     

//***** End Servo 2 speed control***


//*****Servo 3 speed control********

  if (s3psn2 < s3psn1){
      if(s3psn2 < l){
        l=l-1;
        servo3.write(l);
       }
      }
  if (s3psn2 > s3psn1){
      if(s3psn2 > l){
        l=l+1;
        servo3.write(l);    
      }
     }     

//***** End Servo 3 speed control***


//*****Servo 4 speed control********

  if (s4psn2 < s4psn1){
      if(s4psn2 < m){
        m=m-1;
        servo4.write(m);
       }
      }
  if (s4psn2 > s4psn1){
      if(s4psn2 > m){
        m=m+1;
        servo4.write(m);    
      }
     }     

//***** End Servo 4 speed control***
  

//*****Servo 5 speed control********

  if (s5psn2 < s5psn1){
      if(s5psn2 < n){
        n=n-1;
        servo5.write(n);
       }
      }
  if (s5psn2 > s5psn1){
      if(s5psn2 > n){
        n=n+1;
        servo5.write(n);    
      }
     }     

//***** End Servo 5 speed control***

//*****Servo 6 speed control********

  if (s6psn2 < s6psn1){
      if(s6psn2 < o){
        o=o-1;
        servo6.write(o);
       }
      }
  if (s6psn2 > s6psn1){
      if(s6psn2 > o){
        o=o+1;
        servo6.write(o);    
      }
     }     

//***** End Servo 6 speed control***

  delay(speeddelay); 
  }


}

